
#pragma once

#include "ShevArray.h"
#include "Vector2d.h"

//************************* 01.08.2006 ******************************//
//
//        n  
//       1-   
//
//************************* 01.02.2011 ******************************//

Def<Line2d> getLine1 ( CArrRef<Vector2d> point );

Def<Line2d> getLine1 ( CArrRef<Vector2d> point, CArrRef<double> mass );


//*******************************************************************//
//
//          n  
//        2-   
//
//************************* 01.02.2011 ******************************//

Def<Line2d> getLine2 ( CArrRef<Vector2d> point );

Def<Line2d> getLine2 ( CArrRef<Vector2d> point, CArrRef<double> mass );


//************************* 30.12.2009 ******************************//
//
//          n  .
//            
//
//************************* 02.13.2017 ******************************//

Line2d getLineU ( CArrRef<Vector2d> point, double & r );
inline
Line2d getLineU ( CArrRef<Vector2d> point )
{
    double r;
    return getLineU ( point, r );
}


//************************* 11.09.2015 ******************************//
//
//           
//         (mass)   0  1
//
//************************* 11.09.2015 ******************************//

Def<Line2d> getLineR ( CArrRef<Vector2d> point, ArrRef<double> mass );


//************************* 06.12.2006 ******************************//
//
//               n 
//        2-   
//
//************************* 10.01.2011 ******************************//

Def<Line2d> getLine2 ( CArrRef<Segment2d> segm );


//*******************************************************************//
//
//              
//              Sum ( Ri^2 - R^2 )^2 -> min
//
//************************ 05.11.2009 *******************************//

Def<Circle2d> getCirclePnt22 ( CArrRef<Vector2d> p );


//************************ 02.05.2010 *******************************//
//
//              
//               Sum ( Ri - R )^2 -> min
//
//************************ 02.05.2010 *******************************//

Def<Circle2d> getCirclePnt2 ( CArrRef<Vector2d> p );


//************************ 28.11.2009 *******************************//
//
//              
//                Sum | Ri - R | -> min
//      ix1, ix2, ix3 -    
//
//************************ 28.11.2009 *******************************//

Def<Circle2d> getCirclePnt1 ( CArrRef<Vector2d> p, nat & ix1, nat & ix2, nat & ix3 );
Def<Circle2d> getCirclePnt1 ( CArrRef<Vector2d> p );


//************************ 20.09.2009 *******************************//
//
//               
//
//************************ 06.11.2009 *******************************//

Def<Circle2d> getCirclePlg ( CArrRef<Vector2d> poly );


//************************ 11.11.2008 *******************************//
//
//               
//
//************************ 06.11.2009 *******************************//

Def<Ellipse2d> getEllipsePlg ( CArrRef<Vector2d> poly );


//************************ 25.09.2009 *******************************//
//
//               
//
//************************ 06.09.2010 *******************************//

Def<Rectangle2d> getRectanglePlg ( CArrRef<Vector2d> poly );


//************************ 13.07.2005 *******************************//
//
//           
//          ( 1- )
//      ix1, ix2 -      
//
//************************ 24.05.2010 *******************************//

Def<Vector2d> getNearPoint1 ( CArrRef<Line2d> line, nat & ix1, nat & ix2 );
Def<Vector2d> getNearPoint1 ( CArrRef<Line2d> line );


//************************ 30.06.2013 *******************************//
//
//           
//       p- ( p = 4/3, 6/5, 8/7, 10/9 )
//
//************************ 30.06.2013 *******************************//

Def<Vector2d> getNearPoint4_3 ( CArrRef<Line2d> line );
Def<Vector2d> getNearPoint6_5 ( CArrRef<Line2d> line );
Def<Vector2d> getNearPoint8_7 ( CArrRef<Line2d> line );
Def<Vector2d> getNearPoint10_9( CArrRef<Line2d> line );


//************************ 17.01.2005 *******************************//
//
//           
//          ( 2- )
//
//************************ 02.12.2016 *******************************//

Def<Vector2d> getNearPoint2 ( CArrRef<Line2d> line );
Def<Vector2d> getNearPoint2 ( CArrRef<Line2d> line, CArrRef<double> mass );


//************************ 19.12.2009 *******************************//
//
//           
//            (   )
//
//************************ 02.02.2011 *******************************//

Def<Vector2d> getNearPointU ( CArrRef<Line2d> line );


//************************* 03.12.2016 ******************************//
//
//           
//       (mass)   0  1
//
//************************* 03.12.2016 ******************************//

Def<Vector2d> getNearPointR ( CArrRef<Line2d> line, ArrRef<double> mass );


//************************* 20.09.2008 ******************************//
//
//           
//          ( 1- )
//       " ", eps -  
//
//************************* 01.12.2009 ******************************//

Def<Vector2d> getNearPoint1 ( CArrRef<Vector2d> point, double eps = 0 );


//************************* 01.12.2009 ******************************//
//
//           
//          ( 2- )
//
//************************* 01.12.2009 ******************************//

Def<Vector2d> getNearPoint2 ( CArrRef<Vector2d> point );


//************************* 01.12.2009 ******************************//
//
//           
//         (   )
//
//************************* 02.02.2011 ******************************//

Def<Vector2d> getNearPointU ( CArrRef<Vector2d> point );


//************************* 05.03.2017 ******************************//
//
//                       
//
//************************* 30.07.2017 ******************************//

class Spline2d
{
    Vector2d a, b, c;
    mutable bool isDef;
    mutable Def<double> curv;
    mutable double aa, ab, bb, aaa, abc;
public:
    Spline2d () {}
    Spline2d ( const Vector2d & p1, const Vector2d & p2, const Vector2d & n1, const Vector2d & n2 );
    Def<Vector2d> getPoint ( const Vector2d & norm ) const;
    Vector2d getPoint ( double par ) const
    {
        return c + ( b + a * par ) * par;
    }
    Vector2d getNormal ( double par ) const
    {
        return ( b + a * ( par + par ) ).rightPerpendicular().setNorm2();
    }
    double getLength ( double par = 1 ) const;
    double getCurvature ( double par ) const;
    double getCurvatureAvg () const;
};
